--ProSelect v2.0 - Jonathan de blok - www.jdbgraphics.nl 
--26-05-2011
--uses depth sorted raycasting to  select objects. click-and-hold while moving your mouse up/down cycles thorugh the objects. left/right movement expands the selection.
--See video:  http://www.vimeo.com/24265970
--check scriptspot for updates:  http://www.scriptspot.com/3ds-max/scripts/proselect
--
--To install place this script in your [max_root]/scripts/startup  and restart max.  
-- Remove file from this folder and retart max to uninstall.

	proselect_check=false

	tool ProSelect
	(
		local hits = #()
		local startpos = #(0,0)
		local prev=1
		local ind=1
		local rng=1
		local prng=1
		local startsel=($selection as array)
		local rem=false
		local shift=false
	 
		local coordSysTM = Inverse(getViewTM())
		local viewPt = coordSysTM.row4
		local temp=#()
		

		
		fn compareFN v1 v2 =
		(
			v1=v1.pos
			v2=v2.pos
		
			local d = (distance v1 viewPt)-(distance v2 viewPt)
			case of
			(
				(d < 0.): -1
				(d > 0.): 1
				default: 0
			)
		)
		
		fn selectItems=
		(
			if ((prev!=ind or rng!=prng   ) and hits.count>0) do
			(
				deselect  hits[prev] 
				for i=1 to prng do
				(
					f=i+prev- floor(int (prng/2))-1
					if (f>hits.count) then ( f=hits.count)
					if (f<1) then ( f=1)
					deselect hits[f]	
								
				)
												 
				selectMore hits[ind]
				for i=1 to rng do
				(
					f=i+ind-floor(int (rng/2))-1
					if (f>hits.count) then ( f=hits.count)
					if (f<1) then ( f=1)
				
					selectMore hits[f]	
				)
			)
		)
			
		 
		fn StopProSelect = (
	 
				sel=$selection as array
			
				proselect_check=true;
			\
				select startsel
				
				max undo
				
				undo "ProSelect" on
				(
					select sel
				)	
				
				print "ProSelect inactive"
				stopTool ProSelect
			
		)
		
		on freeMove  do 
		(
		 	 
			if (lbutton==false OR hits.count==0 ) then (
	   			StopProSelect()
			) 
			else
			(
				
		 		
				prev=ind
				sel=false
				ind=int (startpos[2]-mouse.pos[2])/25
			 
				prng=rng	
				rng=floor (startpos[1]-mouse.pos[1])/-25
					
				if (ind!=prev OR rng!=prng) do
				( 
					sel=true	
				)		
					
				if (ind<1) do (
					ind=1;
					startpos[2]=(25)+mouse.pos[2]
				)
				
				if (rng<1) do (
					rng=1;
					--startpos[1]=(25)+mouse.pos[1]
				)
					
				if (ind>hits.count) do (
						startpos[2]=(25*hits.count)+mouse.pos[2]
						ind=hits.count
				)
				
					if (rng>hits.count*2) do (
					--	startpos[1]=(25*hits.count*2)+mouse.pos[1]
					rng=hits.count
				)
			  
					selectItems()
			 
			)	
	
		)
		
		on mousePoint click do
		(
				max undo
				max undo
			
			
			 	clearSelection()
				ind=ind+1
				if (ind > temp.count) do (ind=1)
				
				print "single select"
				
				undo "ProSelect" on
				(
				select temp[ind][1]
				)
				
				print "ProSelect inactive"
				stopTool ProSelect
			
		)	 
		
		on start do 
		(	
			print "ProSelect active"
	 		
			startsel=($selection as array)
		 				 
			if (viewport.IsPerspView()==false ) then (
				viewPt=[10000000,100000000,100000000]
			) else (
				coordSysTM = Inverse(getViewTM())
				viewPt = coordSysTM.row4
			)
					 
			temp = intersectRayScene ( mapScreenToWorldRay mouse.pos)
				
			startpos=mouse.pos 
						
			for i=1 to temp.count do
			(
				if 	((findItem startsel  temp[i][1])==0 OR  (findItem startsel  temp[i][1])==startsel.count or startsel.count==1 ) do
				(
					  append hits temp[i][1]  
				)
			)
				
 			qsort hits compareFN

			if (hits.count>0) then
			( 
				 
				pos=findItem hits startsel[startsel.count]
				if (pos==0) then
				(
					StopProSelect()
					pos=1
				)

				startpos[2]=(25*(pos))+mouse.pos[2]
				prev=pos
				ind=pos
				selectMore hits[pos] 
				
			)
			else
			(
				stopTool ProSelect
			)
			
	
		)
		
		on mouseAbort click do
		(
			clearSelection()
			for i=1 to startsel.count do
			(
				selectMore startsel[i]	
			)
			
			StopProSelect()
		)
		
	 
	)

fn CallbackFn1 x e= (

	m=mouse.buttonStates as array
	 
	if (m[1]==1) do
	(	
		if (proselect_check==true and toolmode.commandmode!=#select) then
		(
			proselect_check=false
		)
		else
		(
			proselect_check=false
			
			if (toolmode.commandmode==#select or  toolmode.commandmode==#squash or  toolmode.commandmode==#nuscale or toolmode.commandmode==#move or toolmode.commandmode==#rotate or  toolmode.commandmode==#uscale)  do
			(
				sel=$selection as array
				added=0
				
				for  i=1 to e.count do
				(
					obj= GetAnimByHandle e[i]
					
					if (findItem sel obj>0) do
					(
						added=added+1
					)
						
				) 
				
				if ((added==1 AND sel.count>0) or  sel.count==1 ) do
				(    
					startTool ProSelect
				)
			)	
		)
	)
)

fn CallbackFn2 x e= (
	proselect_check=true;
)

callbackItem = NodeEventCallback  selectionChanged:CallbackFn1 controllerOtherEvent:CallbackFn2  

print "ProSelect loaded"


 
